"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.global = void 0;
const alone_js_1 = __importDefault(require("./alone.js"));
const global = function (name = null, symbol = ".") {
    return {
        symbol: alone_js_1.default.isset(symbol) ? symbol : ".",
        name: "global_" + (alone_js_1.default.isset(name) ? name : "_app_object") + "_cache",
        //设置
        set(key, val = null) {
            const value = alone_js_1.default.is_object(key) ? key : alone_js_1.default.set_arr(key, val, this.symbol);
            this.object(value);
            return value;
        },
        //获取
        get(key = null, def = null) {
            return alone_js_1.default.get_arr(this.list(), key, def, this.symbol) || def;
        },
        //删除,支持传入array删除多个,返回删除数量
        del(key) {
            if (alone_js_1.default.isset(key)) {
                if (alone_js_1.default.is_array(key)) {
                    key.forEach((k) => this.save(alone_js_1.default.del_key(this.list(), k, this.symbol)));
                }
                else {
                    this.save(alone_js_1.default.del_key(this.list(), key, this.symbol));
                }
            }
        },
        //清空
        delete() {
            window[this.name] = {};
        },
        //获取全部
        list() {
            return window[this.name] || {};
        },
        //传入对像合并,true=优选
        object(object = {}, merge = false) {
            return this.save((merge ? alone_js_1.default.array_merge(object, this.list()) : alone_js_1.default.array_merge(this.list(), object)));
        },
        //保存
        save(object) {
            window[this.name] = object;
            return object;
        }
    };
};
exports.global = global;
exports.default = (0, exports.global)('vite_vue');
